Index: LMDZ6/trunk/libf/phylmdiso/pbl_surface_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/pbl_surface_mod.F90	(revision 3939)
+++ LMDZ6/trunk/libf/phylmdiso/pbl_surface_mod.F90	(revision 3940)
@@ -1,4 +1,4 @@
 !
-! $Id: pbl_surface_mod.F90 3435 2019-01-22 15:21:59Z fairhead $
+! $Id: pbl_surface_mod.F90 3906 2021-05-19 10:35:18Z jyg $
 !
 MODULE pbl_surface_mod
@@ -23,8 +23,12 @@
   USE climb_wind_mod,      ONLY : climb_wind_down, climb_wind_up
   USE coef_diff_turb_mod,  ONLY : coef_diff_turb
-  USE wx_pbl_mod,          ONLY : wx_pbl_init, wx_pbl_final, &
-!!                                  wx_pbl_fuse_no_dts, wx_pbl_split_no_dts, &
-!!                                  wx_pbl_fuse, wx_pbl_split
-                                  wx_pbl0_fuse, wx_pbl0_split
+  USE ioipsl_getin_p_mod,  ONLY : getin_p
+  USE cdrag_mod
+  USE stdlevvar_mod
+  USE wx_pbl_var_mod,      ONLY : wx_pbl_init, wx_pbl_final, &
+                                  wx_pbl_prelim_0, wx_pbl_prelim_beta
+  USE wx_pbl_mod,          ONLY : wx_pbl0_merge, wx_pbl_split, wx_pbl_dts_merge, &
+                                  wx_pbl_check, wx_pbl_dts_check, wx_evappot
+  use config_ocean_skin_m, only: activate_ocean_skin
 
   IMPLICIT NONE
@@ -33,10 +37,13 @@
   REAL, ALLOCATABLE, DIMENSION(:), PRIVATE, SAVE     :: fder   ! flux drift
   !$OMP THREADPRIVATE(fder)
-  REAL, ALLOCATABLE, DIMENSION(:,:), PUBLIC, SAVE   :: snow   ! snow at surface
+  REAL, ALLOCATABLE, DIMENSION(:,:), PUBLIC, SAVE    :: snow   ! snow at surface
   !$OMP THREADPRIVATE(snow)
   REAL, ALLOCATABLE, DIMENSION(:,:), PRIVATE, SAVE   :: qsurf  ! humidity at surface
   !$OMP THREADPRIVATE(qsurf)
-  REAL, ALLOCATABLE, DIMENSION(:,:,:), SAVE :: ftsoil ! soil temperature
+  REAL, ALLOCATABLE, DIMENSION(:,:,:), SAVE          :: ftsoil ! soil temperature
   !$OMP THREADPRIVATE(ftsoil)
+  REAL, ALLOCATABLE, DIMENSION(:), SAVE              :: ydTs0, ydqs0  
+                                                     ! nul forced temperature and humidity differences
+  !$OMP THREADPRIVATE(ydTs0, ydqs0)
 
 #ifdef ISO
@@ -51,4 +58,7 @@
   INTEGER, SAVE :: iflag_pbl_surface_t2m_bug
   !$OMP THREADPRIVATE(iflag_pbl_surface_t2m_bug)
+  INTEGER, SAVE :: iflag_new_t2mq2m
+  !$OMP THREADPRIVATE(iflag_new_t2mq2m)
+
 !FC
 !  integer, save :: iflag_frein
@@ -78,5 +88,4 @@
     REAL, DIMENSION(klon, nbsrf), INTENT(IN)          :: qsurf_rst
     REAL, DIMENSION(klon, nsoilmx, nbsrf), INTENT(IN) :: ftsoil_rst
-
   
 ! Local variables
@@ -102,9 +111,16 @@
     IF (ierr /= 0) CALL abort_physic('pbl_surface_init', 'pb in allocation',1)
 
+    ALLOCATE(ydTs0(klon), stat=ierr)
+    IF (ierr /= 0) CALL abort_physic('pbl_surface_init', 'pb in allocation',1)
+
+    ALLOCATE(ydqs0(klon), stat=ierr)
+    IF (ierr /= 0) CALL abort_physic('pbl_surface_init', 'pb in allocation',1)
+
     fder(:)       = fder_rst(:)
     snow(:,:)     = snow_rst(:,:)
     qsurf(:,:)    = qsurf_rst(:,:)
     ftsoil(:,:,:) = ftsoil_rst(:,:,:)
-
+    ydTs0(:) = 0.
+    ydqs0(:) = 0.
 
 !****************************************************************************************
@@ -152,4 +168,5 @@
     iflag_pbl_surface_t2m_bug=0
     CALL getin_p('iflag_pbl_surface_t2m_bug',iflag_pbl_surface_t2m_bug)
+    WRITE(lunout,*) 'iflag_pbl_surface_t2m_bug=',iflag_pbl_surface_t2m_bug
 !FC
 !    iflag_frein = 0
@@ -240,6 +257,6 @@
        debut,     lafin,                              &
        rlon,      rlat,      rugoro,   rmu0,          &
-       zsig,      lwdown_m,  pphi,     cldt,          &
-       rain_f,    snow_f,    solsw_m,  sollw_m,       &
+       lwdown_m,  cldt,          &
+       rain_f,    snow_f,    solsw_m,  solswfdiff_m, sollw_m,       &
        gustiness,                                     &
        t,         q,         u,        v,             &
@@ -252,7 +269,10 @@
        ts,SFRWL,   alb_dir, alb_dif,ustar, u10m, v10m,wstar, &
        cdragh,    cdragm,   zu1,    zv1,              &
+!jyg<   (26/09/2019)
+       beta, &
+!>jyg
        alb_dir_m,    alb_dif_m,  zxsens,   zxevap,    &
        alb3_lic,  runoff,    snowhgt,   qsnow,     to_ice,    sissnow,  &
-       zxtsol,    zxfluxlat, zt2m,     qsat2m,        &
+       zxtsol,    zxfluxlat, zt2m,     qsat2m, zn2mout, &
        d_t,       d_q,       d_u,      d_v, d_t_diss, & 
 !!! nrlmd+jyg le 02/05/2011 et le 20/02/2012
@@ -275,5 +295,6 @@
        s_therm,   s_trmb1,   s_trmb2,  s_trmb3,       &
        zustar,zu10m,  zv10m,    fder_print,    &
-       zxqsurf,   rh2m,      zxfluxu,  zxfluxv,       &
+       zxqsurf, delta_qsurf,                       &
+       rh2m,      zxfluxu,  zxfluxv,               &
        z0m, z0h,   agesno,  sollw,    solsw,         &
        d_ts,      evap,    fluxlat,  t2m,           &
@@ -283,5 +304,5 @@
 !jyg<
 !!       zxfluxt,   zxfluxq,   q2m,      flux_q, tke,   &
-       zxfluxt,   zxfluxq,   q2m,      flux_q, tke_x,   &
+       zxfluxt,   zxfluxq,   q2m,      flux_q, tke_x,  &
 !>jyg
 !!! nrlmd+jyg le 02/05/2011 et le 20/02/2012
@@ -338,7 +359,5 @@
 ! z0m, z0h ----input-R- longeur de rugosite (en m)
 ! Martin
-! zsig-----input-R- slope
 ! cldt-----input-R- total cloud fraction
-! pphi-----input-R- geopotentiel de chaque couche (g z) (reference sol)
 ! Martin
 !
@@ -370,4 +389,5 @@
     USE carbon_cycle_mod,   ONLY : carbon_cycle_cpl, carbon_cycle_tr, level_coupling_esm 
     USE carbon_cycle_mod,   ONLY : co2_send, nbcf_out, fields_out, yfields_out, cfname_out
+    use hbtm_mod, only: hbtm
     USE indice_sol_mod
     USE time_phylmdz_mod,   ONLY : day_ini,annee_ref,itau_phy
@@ -385,4 +405,14 @@
 #endif
     USE ioipsl_getin_p_mod, ONLY : getin_p
+    use phys_state_var_mod, only: ds_ns, dt_ns, delta_sst, delta_sal, zsig, zmea
+    use phys_output_var_mod, only: dter, dser, tkt, tks, taur, sss
+#ifdef CPP_XIOS
+    USE wxios, ONLY: missing_val
+#else
+    use netcdf, only: missing_val => nf90_fill_real
+#endif
+
+     
+
 
     IMPLICIT NONE
@@ -412,4 +442,5 @@
     REAL, DIMENSION(klon),        INTENT(IN)        :: snow_f  ! snow fall
     REAL, DIMENSION(klon),        INTENT(IN)        :: solsw_m ! net shortwave radiation at mean surface
+    REAL, DIMENSION(klon),        INTENT(IN)        :: solswfdiff_m ! diffuse fraction fordownward shortwave radiation at mean surface
     REAL, DIMENSION(klon),        INTENT(IN)        :: sollw_m ! net longwave radiation at mean surface
     REAL, DIMENSION(klon,klev),   INTENT(IN)        :: t       ! temperature (K)
@@ -421,11 +452,8 @@
     REAL, DIMENSION(klon, nbsrf), INTENT(IN)        :: pctsrf  ! sub-surface fraction
 ! Martin
-    REAL, DIMENSION(klon),        INTENT(IN)        :: zsig    ! slope
     REAL, DIMENSION(klon),        INTENT(IN)        :: lwdown_m ! downward longwave radiation at mean s    
     REAL, DIMENSION(klon),        INTENT(IN)        :: gustiness ! gustiness
 
     REAL, DIMENSION(klon),        INTENT(IN)        :: cldt    ! total cloud fraction
-    REAL, DIMENSION(klon,klev),   INTENT(IN)        :: pphi    ! geopotential (m2/s2)
-! Martin
 
 #ifdef ISO
@@ -451,4 +479,7 @@
 ! Input/Output variables
 !****************************************************************************************
+!jyg<
+    REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: beta    ! Aridity factor
+!>jyg
     REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: ts      ! temperature at surface (K)
     REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: delta_tsurf !surface temperature difference between
@@ -496,4 +527,5 @@
     REAL, DIMENSION(klon),        INTENT(OUT)       :: zxfluxlat  ! latent flux, mean for each grid point
     REAL, DIMENSION(klon),        INTENT(OUT)       :: zt2m       ! temperature at 2m, mean for each grid point
+    INTEGER, DIMENSION(klon, 6),  INTENT(OUT)       :: zn2mout    ! number of times the 2m temperature is out of the [tsol,temp]
     REAL, DIMENSION(klon),        INTENT(OUT)       :: qsat2m
     REAL, DIMENSION(klon, klev),  INTENT(OUT)       :: d_t        ! change in temperature 
@@ -560,13 +592,14 @@
     REAL, DIMENSION(klon),        INTENT(OUT)       :: fder_print ! fder for printing (=fder(i) + dflux_t(i) + dflux_q(i))
     REAL, DIMENSION(klon),        INTENT(OUT)       :: zxqsurf    ! humidity at surface, mean for each grid point
+    REAL, DIMENSION(klon),        INTENT(OUT)       :: delta_qsurf! humidity difference at surface, mean for each grid point
     REAL, DIMENSION(klon),        INTENT(OUT)       :: rh2m       ! relative humidity at 2m
     REAL, DIMENSION(klon, klev),  INTENT(OUT)       :: zxfluxu    ! u wind tension, mean for each grid point
     REAL, DIMENSION(klon, klev),  INTENT(OUT)       :: zxfluxv    ! v wind tension, mean for each grid point
-    REAL, DIMENSION(klon, nbsrf+1), INTENT(INOUT)     :: z0m,z0h      ! rugosity length (m)
-    REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)       :: agesno   ! age of snow at surface
+    REAL, DIMENSION(klon, nbsrf+1), INTENT(INOUT)   :: z0m,z0h      ! rugosity length (m)
+    REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: agesno   ! age of snow at surface
     REAL, DIMENSION(klon, nbsrf), INTENT(OUT)       :: solsw      ! net shortwave radiation at surface 
     REAL, DIMENSION(klon, nbsrf), INTENT(OUT)       :: sollw      ! net longwave radiation at surface
     REAL, DIMENSION(klon, nbsrf), INTENT(OUT)       :: d_ts       ! change in temperature at surface
-    REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)       :: evap     ! evaporation at surface
+    REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: evap     ! evaporation at surface
     REAL, DIMENSION(klon, nbsrf), INTENT(OUT)       :: fluxlat    ! latent flux
     REAL, DIMENSION(klon, nbsrf), INTENT(OUT)       :: t2m        ! temperature at 2 meter height
@@ -605,5 +638,5 @@
 
 ! Martin
-! sisvat
+! inlandsis
     REAL, DIMENSION(klon),       INTENT(OUT)        :: qsnow      ! snow water content
     REAL, DIMENSION(klon),       INTENT(OUT)        :: snowhgt    ! snow height
@@ -632,5 +665,5 @@
     INTEGER                            :: n 
 ! << PC
-    INTEGER                            :: iflag_split 
+    INTEGER                            :: iflag_split, iflag_split_ref 
     INTEGER                            :: i, k, nsrf 
     INTEGER                            :: knon, j
@@ -643,8 +676,10 @@
     REAL, DIMENSION(klon)              :: r_co2_ppm     ! taux CO2 atmosphere
     REAL, DIMENSION(klon)              :: yts, yz0m, yz0h, ypct
+    REAL, DIMENSION(klon)              :: yz0h_old
 !albedo SB >>>
     REAL, DIMENSION(klon)              :: yalb,yalb_vis
 !albedo SB <<<
     REAL, DIMENSION(klon)              :: yt1, yq1, yu1, yv1
+    REAL, DIMENSION(klon)              :: yqa
     REAL, DIMENSION(klon)              :: ysnow, yqsurf, yagesno, yqsol
     REAL, DIMENSION(klon)              :: yrain_f, ysnow_f
@@ -670,4 +705,6 @@
     REAL, DIMENSION(klon)              :: y_flux_u1, y_flux_v1
     REAL, DIMENSION(klon)              :: yt2m, yq2m, yu10m
+    INTEGER, DIMENSION(klon, nbsrf, 6) :: yn2mout, yn2mout_x, yn2mout_w
+    INTEGER, DIMENSION(klon, nbsrf, 6) :: n2mout, n2mout_x, n2mout_w
     REAL, DIMENSION(klon)              :: yustar
     REAL, DIMENSION(klon)              :: ywstar
@@ -690,4 +727,5 @@
     REAL, DIMENSION(klon)              :: yz0h_oupas
     REAL, DIMENSION(klon)              :: yfluxsens
+    REAL, DIMENSION(klon)              :: AcoefH_0, AcoefQ_0, BcoefH_0, BcoefQ_0
     REAL, DIMENSION(klon)              :: AcoefH, AcoefQ, BcoefH, BcoefQ
 #ifdef ISO
@@ -696,5 +734,5 @@
     REAL, DIMENSION(klon)              :: AcoefU, AcoefV, BcoefU, BcoefV
     REAL, DIMENSION(klon)              :: ypsref
-    REAL, DIMENSION(klon)              :: yevap, ytsurf_new, yalb3_new
+    REAL, DIMENSION(klon)              :: yevap, yevap_pot, ytsurf_new, yalb3_new
 !albedo SB >>>
     REAL, DIMENSION(klon,nsw)          :: yalb_dir_new, yalb_dif_new
@@ -708,5 +746,5 @@
     REAL, DIMENSION(klon,klev)         :: y_flux_u, y_flux_v
     REAL, DIMENSION(klon,klev)         :: ycoefh, ycoefm,ycoefq
-    REAL, DIMENSION(klon)              :: ycdragh, ycdragm
+    REAL, DIMENSION(klon)              :: ycdragh, ycdragq, ycdragm
     REAL, DIMENSION(klon,klev)         :: yu, yv
     REAL, DIMENSION(klon,klev)         :: yt, yq
@@ -746,5 +784,6 @@
     REAL, DIMENSION(klon,klev)         :: ycoefh_x, ycoefm_x, ycoefh_w, ycoefm_w
     REAL, DIMENSION(klon,klev)         :: ycoefq_x, ycoefq_w
-    REAL, DIMENSION(klon)              :: ycdragh_x, ycdragm_x, ycdragh_w, ycdragm_w
+    REAL, DIMENSION(klon)              :: ycdragh_x, ycdragh_w, ycdragq_x, ycdragq_w
+    REAL, DIMENSION(klon)              :: ycdragm_x, ycdragm_w
     REAL, DIMENSION(klon)              :: AcoefH_x, AcoefQ_x, BcoefH_x, BcoefQ_x
     REAL, DIMENSION(klon)              :: AcoefH_w, AcoefQ_w, BcoefH_w, BcoefQ_w
@@ -767,5 +806,8 @@
     REAL                               :: zx_qs_surf, zcor_surf, zdelta_surf
     REAL, DIMENSION(klon)              :: ytsurf_th, yqsatsurf
+!jyg<
     REAL, DIMENSION(klon)              :: ybeta
+    REAL, DIMENSION(klon)              :: ybeta_prev
+!>jyg
     REAL, DIMENSION(klon, klev)        :: d_u_x
     REAL, DIMENSION(klon, klev)        :: d_u_w
@@ -915,5 +957,14 @@
 !!! nrlmd le 13/06/2011
     REAL, DIMENSION(klon)              :: y_delta_flux_t1, y_delta_flux_q1, y_delta_flux_u1, y_delta_flux_v1
-    REAL, DIMENSION(klon)              :: y_delta_tsurf,delta_coef,tau_eq
+    REAL, DIMENSION(klon)              :: y_delta_tsurf, y_delta_tsurf_new
+    REAL, DIMENSION(klon)              :: delta_coef, tau_eq
+    REAL, DIMENSION(klon)              :: HTphiT_b, dd_HTphiT, HTphiQ_b, dd_HTphiQ, HTRn_b, dd_HTRn
+    REAL, DIMENSION(klon)              :: phiT0_b, dphiT0, phiQ0_b, dphiQ0, Rn0_b, dRn0
+    REAL, DIMENSION(klon)              :: y_delta_qsurf
+    REAL, DIMENSION(klon)              :: y_delta_qsats
+    REAL, DIMENSION(klon)              :: yg_T, yg_Q
+    REAL, DIMENSION(klon)              :: yGamma_dTs_phiT, yGamma_dQs_phiQ
+    REAL, DIMENSION(klon)              :: ydTs_ins, ydqs_ins
+!
     REAL, PARAMETER                    :: facteur=2./sqrt(3.14)
     REAL, PARAMETER                    :: inertia=2000.
@@ -928,5 +979,7 @@
     REAL, DIMENSION(klon)              :: Kech_m
     REAL, DIMENSION(klon)              :: Kech_m_x, Kech_m_w 
-    REAL, DIMENSION(klon)              :: yts_x,yts_w
+    REAL, DIMENSION(klon)              :: yts_x, yts_w
+    REAL, DIMENSION(klon)              :: yqsatsrf0_x, yqsatsrf0_w
+    REAL, DIMENSION(klon)              :: yqsurf_x, yqsurf_w
 !jyg<
 !!    REAL, DIMENSION(klon)              :: Kech_Hp, Kech_H_xp, Kech_H_wp
@@ -935,7 +988,7 @@
 !!    REAL, DIMENSION(klon)              :: Kech_Vp, Kech_V_xp, Kech_V_wp
 !>jyg
-!jyg<
-    REAL, DIMENSION(klon)              :: ah, bh     ! coefficients of the delta_Tsurf equation
-!>jyg
+
+    REAL                               :: fact_cdrag
+    REAL                               :: z1lay
 
     REAL                               :: vent
@@ -971,9 +1024,15 @@
     REAL, DIMENSION(klon)              :: ytoice
     REAL, DIMENSION(klon)              :: ysnowhgt, yqsnow, ysissnow, yrunoff
+    REAL, DIMENSION(klon)              :: yzmea
     REAL, DIMENSION(klon)              :: yzsig
-    REAL, DIMENSION(klon,klev)         :: ypphi
     REAL, DIMENSION(klon)              :: ycldt
     REAL, DIMENSION(klon)              :: yrmu0
     ! Martin
+
+    REAL, DIMENSION(klon):: ydelta_sst, ydelta_sal, yds_ns, ydt_ns, ydter, ydser, &
+         ytkt, ytks, ytaur, ysss
+    ! compression of delta_sst, delta_sal, ds_ns, dt_ns, dter, dser, tkt, tks,
+    ! taur, sss on ocean points
+
 #ifdef ISO
     REAL, DIMENSION(klon)       :: h1
@@ -991,5 +1050,6 @@
 !
 !!jyg      iflag_split = mod(iflag_pbl_split,2)
-      iflag_split = mod(iflag_pbl_split,10)
+!!jyg      iflag_split = mod(iflag_pbl_split,10)
+      iflag_split_ref = mod(iflag_pbl_split,10)
 
 #ifdef ISO      
@@ -1038,9 +1098,15 @@
 
     IF (first_call) THEN
+
+       iflag_new_t2mq2m=1
+       CALL getin_p('iflag_new_t2mq2m',iflag_new_t2mq2m)
+       WRITE(lunout,*) 'pbl_iflag_new_t2mq2m=',iflag_new_t2mq2m
+
        print*,'PBL SURFACE AVEC GUSTINESS'
        first_call=.FALSE.
       
        ! Initialize ok_flux_surf (for 1D model)
-       if (klon_glo>1) ok_flux_surf=.FALSE.
+       IF (klon_glo>1) ok_flux_surf=.FALSE.
+       IF (klon_glo>1) ok_forc_tsurf=.FALSE.
 
        ! intialize beta_land
@@ -1113,4 +1179,5 @@
  zxfluxlat(:)=0.
  zt2m(:)=0. ; zq2m(:)=0. ; qsat2m(:)=0. ; rh2m(:)=0.
+ zn2mout(:,:)=0 ;
  d_t(:,:)=0. ; d_t_diss(:,:)=0. ; d_q(:,:)=0. ; d_u(:,:)=0. ; d_v(:,:)=0.
  zcoefh(:,:,:)=0. ; zcoefm(:,:,:)=0.
@@ -1128,4 +1195,5 @@
  fder_print(:)=0.
  zxqsurf(:)=0.
+ delta_qsurf(:) = 0.
  zxfluxu(:,:)=0. ; zxfluxv(:,:)=0.
  solsw(:,:)=0. ; sollw(:,:)=0.
@@ -1164,4 +1232,5 @@
 !!    tke(:,:,is_ave)=0.
     tke_x(:,:,is_ave)=0.
+
     wake_dltke(:,:,is_ave)=0.
 !>jyg
@@ -1184,5 +1253,5 @@
     yqsurf = 0.0  ; yalb = 0.0 ; yalb_vis = 0.0
 !albedo SB <<<
-    yrain_f = 0.0 ; ysnow_f = 0.0    ; yfder = 0.0     ; ysolsw = 0.0    
+    yrain_f = 0.0 ; ysnow_f = 0.0    ; yfder = 0.0     ; ysolsw = 0.0
     ysollw = 0.0  ; yz0m = 0.0 ; yz0h = 0.0    ; yu1 = 0.0    
     yv1 = 0.0     ; ypaprs = 0.0     ; ypplay = 0.0
@@ -1195,5 +1264,6 @@
 !!    d_t_diss= 0.0 ;d_u = 0.0     ; d_v = 0.0 
     yqsol = 0.0    
-    ytherm = 0.0  ; ytke=0.
+
+    ytke=0.
 !FC 
     y_treedrg=0.
@@ -1202,5 +1272,5 @@
     ysnowhgt = 0.0; yqsnow = 0.0     ; yrunoff = 0.0   ; ytoice =0.0
     yalb3_new = 0.0  ; ysissnow = 0.0 
-    ypphi = 0.0   ; ycldt = 0.0      ; yrmu0 = 0.0
+    ycldt = 0.0      ; yrmu0 = 0.0
     ! Martin
 
@@ -1218,6 +1288,11 @@
     y_delta_flux_t1=0.
     ydtsurf_th=0.
-    yts_x=0.      ; yts_w=0.
-    y_delta_tsurf=0.
+    yts_x(:)=0.      ; yts_w(:)=0.
+    y_delta_tsurf(:)=0. ; y_delta_qsurf(:)=0.
+    yqsurf_x(:)=0.      ; yqsurf_w(:)=0.
+    yg_T(:) = 0. ;        yg_Q(:) = 0.
+    yGamma_dTs_phiT(:) = 0. ; yGamma_dQs_phiQ(:) = 0.
+    ydTs_ins(:) = 0. ; ydqs_ins(:) = 0.
+
 !!!
     ytsoil = 999999. 
@@ -1410,12 +1485,5 @@
        DO i = 1, klon
           sollw(i,nsrf) = sollw_m(i) + 4.0*RSIGMA*ztsol(i)**3 * (ztsol(i)-ts(i,nsrf))
-
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-!         ! Martin
-! Apparently introduced for sisvat but not used
-!         sollwd(i,nsrf)= sollwd_m(i)
-!         ! Martin
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-
+!--OB this line is not satisfactory because alb is the direct albedo not total albedo
           solsw(i,nsrf) = solsw_m(i) * (1.-alb(i,nsrf)) / (1.-alb_m(i))
        ENDDO
@@ -1440,4 +1508,8 @@
 !>al1
 
+!--OB add diffuse fraction of SW down
+   DO n=1,nbcf_out
+       IF (cfname_out(n) == "swdownfdiff" ) fields_out(:,n) = solswfdiff_m(:)
+   ENDDO
 ! >> PC
    IF (carbon_cycle_cpl .AND. carbon_cycle_tr .AND. nbcf_out.GT.0 ) THEN
@@ -1461,7 +1533,18 @@
 ! 
 !****************************************************************************************
-   
-    loop_nbsrf: DO nsrf = 1, nbsrf
+                                                                          !<<<<<<<<<<<<<
+    loop_nbsrf: DO nsrf = 1, nbsrf                                        !<<<<<<<<<<<<<
+                                                                          !<<<<<<<<<<<<<
        IF (prt_level >=10) print *,' Loop nsrf ',nsrf
+!
+       IF (iflag_split_ref == 3) THEN
+         IF (nsrf == is_oce) THEN
+            iflag_split = 1
+         ELSE
+            iflag_split=0
+         ENDIF   !! (nsrf == is_oce)
+       ELSE                     
+         iflag_split = iflag_split_ref
+       ENDIF   !! (iflag_split_ref == 3)
 
 ! Search for index(ni) and size(knon) of domaine to treat
@@ -1499,4 +1582,21 @@
 !****************************************************************************************
 
+!
+!jyg<    (20190926)
+!   Provisional : set ybeta to standard values
+       IF (nsrf .NE. is_ter) THEN
+           ybeta(:) = 1.
+       ELSE
+           IF (iflag_split .EQ. 0) THEN
+              ybeta(:) = 1.
+           ELSE
+             DO j = 1, knon
+                i = ni(j)
+                ybeta(j)   = beta(i,nsrf)
+             ENDDO
+           ENDIF  ! (iflag_split .LE.1)
+       ENDIF !  (nsrf .NE. is_ter)
+!>jyg
+!
        DO j = 1, knon
           i = ni(j)
@@ -1531,5 +1631,6 @@
           ywindsp(j) = windsp(i,nsrf)
 !>jyg
-          ! Martin
+          ! Martin and Etienne
+          yzmea(j)   = zmea(i)
           yzsig(j)   = zsig(i)
           ycldt(j)   = cldt(i)
@@ -1656,4 +1757,5 @@
              ytke_w(j,k)      = tke_x(i,k,nsrf)+wake_dltke(i,k,nsrf)
              ywake_dltke(j,k) = wake_dltke(i,k,nsrf)
+            
 !>jyg
           ENDDO
@@ -1695,4 +1797,14 @@
           ENDDO
        ENDIF
+
+       if (nsrf == is_oce .and. activate_ocean_skin >= 1) then
+          if (activate_ocean_skin == 2 .and. type_ocean == "couple") then
+             ydelta_sal(:knon) = delta_sal(ni(:knon))
+             ydelta_sst(:knon) = delta_sst(ni(:knon))
+          end if
+          
+          yds_ns(:knon) = ds_ns(ni(:knon))
+          ydt_ns(:knon) = dt_ns(ni(:knon))
+       end if
        
 !****************************************************************************************
@@ -1735,4 +1847,5 @@
       ENDDO
      ENDIF
+
         IF (prt_level >=10) print *,'clcdrag -> ycdragh ', ycdragh
        ELSE  !(iflag_split .eq.0)
@@ -1749,7 +1862,9 @@
            speed_x(i) = SQRT(yu_x(i,1)**2+yv_x(i,1)**2)
         ENDDO
-        CALL cdrag(knon, nsrf, &
+
+
+            CALL cdrag(knon, nsrf, &
             speed_x, yt_x(:,1), yq_x(:,1), zgeo1_x, ypaprs(:,1),&
-            yts_x, yqsurf, yz0m, yz0h, &
+            yts_x, yqsurf_x, yz0m, yz0h, &
             ycdragm_x, ycdragh_x, zri1_x, pref_x )
 
@@ -1778,5 +1893,5 @@
         CALL cdrag(knon, nsrf, &
             speed_w, yt_w(:,1), yq_w(:,1), zgeo1_w, ypaprs(:,1),&
-            yts_w, yqsurf, yz0m, yz0h, &
+            yts_w, yqsurf_w, yz0m, yz0h, &
             ycdragm_w, ycdragh_w, zri1_w, pref_w )
 !
@@ -1818,4 +1933,5 @@
       print *,' args coef_diff_turb: ycdragh ', ycdragh
       print *,' args coef_diff_turb: ytke ', ytke
+
        ENDIF
         CALL coef_diff_turb(dtime, nsrf, knon, ni,  &
@@ -1847,7 +1963,8 @@
       print *,' args coef_diff_turb: ycdragh_x ', ycdragh_x
       print *,' args coef_diff_turb: ytke_x ', ytke_x
+
        ENDIF
         CALL coef_diff_turb(dtime, nsrf, knon, ni,  &
-            ypaprs, ypplay, yu_x, yv_x, yq_x, yt_x, yts_x, yqsurf, ycdragm_x, &
+            ypaprs, ypplay, yu_x, yv_x, yq_x, yt_x, yts_x, yqsurf_x, ycdragm_x, &
             ycoefm_x, ycoefh_x, ytke_x,y_treedrg)
 !            ycoefm_x, ycoefh_x, ytke_x)
@@ -1877,5 +1994,5 @@
        ENDIF
         CALL coef_diff_turb(dtime, nsrf, knon, ni,  &
-            ypaprs, ypplay, yu_w, yv_w, yq_w, yt_w, yts_w, yqsurf, ycdragm_w, &
+            ypaprs, ypplay, yu_w, yv_w, yq_w, yt_w, yts_w, yqsurf_w, ycdragm_w, &
             ycoefm_w, ycoefh_w, ytke_w,y_treedrg)
 !            ycoefm_w, ycoefh_w, ytke_w)
@@ -2029,80 +2146,115 @@
          yxt1(:,:) = yxt(:,:,1)
 #endif
-!!       ELSE IF (iflag_split .eq. 1) THEN
-!!!
-!jyg<
-!!         CALL wx_pbl_fuse_no_dts(knon, dtime, ypplay, ywake_s, &
-!!                                 yt_x, yt_w, yq_x, yq_w, &
-!!                                 yu_x, yu_w, yv_x, yv_w, &
-!!                                 ycdragh_x, ycdragh_w, ycdragm_x, ycdragm_w, &
-!!                                 AcoefH_x, AcoefH_w, AcoefQ_x, AcoefQ_w, &
-!!                                 AcoefU_x, AcoefU_w, AcoefV_x, AcoefV_w, &
-!!                                 BcoefH_x, BcoefH_w, BcoefQ_x, BcoefQ_w, &
-!!                                 BcoefU_x, BcoefU_w, BcoefV_x, BcoefV_w, &
-!!                                 AcoefH, AcoefQ, AcoefU, AcoefV, &
-!!                                 BcoefH, BcoefQ, BcoefU, BcoefV, &
-!!                                 ycdragh, ycdragm, &
-!!                                 yt1, yq1, yu1, yv1 &
-!!                                 )
+
        ELSE IF (iflag_split .ge. 1) THEN
-         CALL wx_pbl0_fuse(knon, dtime, ypplay, ywake_s, &
+#ifdef ISO
+        call abort_gcm('pbl_surface_mod 2149','isos pas encore dans iflag_split=1',1)
+#endif
+
+!
+! Cdragq computation
+! ------------------
+    !******************************************************************************
+    ! Cdragq computed from cdrag
+    ! The difference comes only from a factor (f_z0qh_oce) on z0, so that
+    ! it can be computed inside wx_pbl0_merge
+    ! More complicated appraches may require the propagation through
+    ! pbl_surface of an independant cdragq variable.
+    !******************************************************************************
+!
+    IF ( f_z0qh_oce .ne. 1. .and. nsrf .eq.is_oce) THEN
+       ! Si on suit les formulations par exemple de Tessel, on 
+       ! a z0h=0.4*nu/u*, z0q=0.62*nu/u*, d'ou f_z0qh_oce=0.62/0.4=1.55
+!!       ycdragq_x(1:knon)=ycdragh_x(1:knon)*                                      &
+!!            log(z1lay(1:knon)/yz0h(1:knon))/log(z1lay(1:knon)/(f_z0qh_oce*yz0h(1:knon)))
+!!       ycdragq_w(1:knon)=ycdragh_w(1:knon)*                                      &
+!!            log(z1lay(1:knon)/yz0h(1:knon))/log(z1lay(1:knon)/(f_z0qh_oce*yz0h(1:knon)))
+!
+       DO j = 1,knon
+         z1lay = zgeo1(j)/RG
+         fact_cdrag = log(z1lay/yz0h(j))/log(z1lay/(f_z0qh_oce*yz0h(j)))
+         ycdragq_x(j)=ycdragh_x(j)*fact_cdrag
+         ycdragq_w(j)=ycdragh_w(j)*fact_cdrag
+!!     Print *,'YYYYpbl0: fact_cdrag ', fact_cdrag
+       ENDDO  ! j = 1,knon
+!
+!!  Print *,'YYYYpbl0: z1lay, yz0h, f_z0qh_oce, ycdragh_w, ycdragq_w ', &
+!!                z1lay, yz0h(1:knon), f_z0qh_oce, ycdragh_w(1:knon), ycdragq_w(1:knon)
+    ELSE
+       ycdragq_x(1:knon)=ycdragh_x(1:knon)
+       ycdragq_w(1:knon)=ycdragh_w(1:knon)
+    ENDIF  ! ( f_z0qh_oce .ne. 1. .and. nsrf .eq.is_oce)
+!
+         CALL wx_pbl_prelim_0(knon, nsrf, dtime, ypplay, ypaprs, ywake_s,  &
+                         yts, y_delta_tsurf, ygustiness, &
                          yt_x, yt_w, yq_x, yq_w, &
                          yu_x, yu_w, yv_x, yv_w, &
-                         ycdragh_x, ycdragh_w, ycdragm_x, ycdragm_w, &
+                         ycdragh_x, ycdragh_w, ycdragq_x, ycdragq_w, &
+                         ycdragm_x, ycdragm_w, &
+                         AcoefH_x, AcoefH_w, AcoefQ_x, AcoefQ_w, &
+                         AcoefU_x, AcoefU_w, AcoefV_x, AcoefV_w, &
+                         BcoefH_x, BcoefH_w, BcoefQ_x, BcoefQ_w, &
+                         BcoefU_x, BcoefU_w, BcoefV_x, BcoefV_w  &
+                         )
+         CALL wx_pbl_prelim_beta(knon, dtime, ywake_s, ybeta,  &
+                         BcoefQ_x, BcoefQ_w  &
+                         )
+         CALL wx_pbl0_merge(knon, ypplay, ypaprs,  &
+                         ywake_s, ydTs0, ydqs0, &
+                         yt_x, yt_w, yq_x, yq_w, &
+                         yu_x, yu_w, yv_x, yv_w, &
+                         ycdragh_x, ycdragh_w, ycdragq_x, ycdragq_w, &
+                         ycdragm_x, ycdragm_w, &
                          AcoefH_x, AcoefH_w, AcoefQ_x, AcoefQ_w, &
                          AcoefU_x, AcoefU_w, AcoefV_x, AcoefV_w, &
                          BcoefH_x, BcoefH_w, BcoefQ_x, BcoefQ_w, &
                          BcoefU_x, BcoefU_w, BcoefV_x, BcoefV_w, &
-                         AcoefH, AcoefQ, AcoefU, AcoefV, &
-                         BcoefH, BcoefQ, BcoefU, BcoefV, &
-                         ycdragh, ycdragm, &
+                         AcoefH_0, AcoefQ_0, AcoefU, AcoefV, &
+                         BcoefH_0, BcoefQ_0, BcoefU, BcoefV, &
+                         ycdragh, ycdragq, ycdragm, &
                          yt1, yq1, yu1, yv1 &
-#ifdef ISO
-                         ,yxt_x,yxt_w,yxt1 &
-#endif
                          )
-!!       ELSE IF (iflag_split .ge.2) THEN
-!!!    Provisoire
-!!         ah(:) = 0.
-!!         bh(:) = 0.
-!!         IF (nsrf == is_oce) THEN
-!!           ybeta(:) = 1.
-!!         ELSE
-!!           ybeta(:) = beta_land
-!!         ENDIF
-!!         ycdragh(:) = ywake_s(:)*ycdragh_w(:) + (1.-ywake_s(:))*ycdragh_x(:)
-!!         CALL wx_dts(knon, nsrf, ywake_cstar, ywake_s, ywake_dens, &
-!!                     yts, ypplay(:,1), ybeta, ycdragh , ypaprs(:,1), &
-!!                     yq(:,1), yt(:,1), yu(:,1), yv(:,1), ygustiness, &
-!!                     ah, bh &
-!!                     )
-!!!
-!!         CALL wx_pbl_fuse(knon, dtime, ypplay, ywake_s, &
-!!                         yt_x, yt_w, yq_x, yq_w, &
-!!                         yu_x, yu_w, yv_x, yv_w, &
-!!                         ycdragh_x, ycdragh_w, ycdragm_x, ycdragm_w, &
-!!                         AcoefH_x, AcoefH_w, AcoefQ_x, AcoefQ_w, &
-!!                         AcoefU_x, AcoefU_w, AcoefV_x, AcoefV_w, &
-!!                         BcoefH_x, BcoefH_w, BcoefQ_x, BcoefQ_w, &
-!!                         BcoefU_x, BcoefU_w, BcoefV_x, BcoefV_w, &
-!!                         ah, bh, &
-!!                         AcoefH, AcoefQ, AcoefU, AcoefV, &
-!!                         BcoefH, BcoefQ, BcoefU, BcoefV, &
-!!                         ycdragh, ycdragm, &
-!!                         yt1, yq1, yu1, yv1 &
-!!                         )
-!>jyg
-!!!
-         ENDIF  ! (iflag_split .eq.0)
+         IF (iflag_split .eq. 2 .AND. nsrf .ne. is_oce) THEN
+           CALL wx_pbl_dts_merge(knon, dtime, ypplay, ypaprs, &
+                           ywake_s, ybeta, ywake_cstar, ywake_dens, &
+                           AcoefH_x, AcoefH_w, &
+                           BcoefH_x, BcoefH_w, &
+                           AcoefH_0, AcoefQ_0, BcoefH_0, BcoefQ_0,  &
+                           AcoefH, AcoefQ, BcoefH, BcoefQ,  &
+                           HTphiT_b, dd_HTphiT, HTphiQ_b, dd_HTphiQ, HTRn_b, dd_HTRn, &
+                           phiT0_b, dphiT0, phiQ0_b, dphiQ0, Rn0_b, dRn0, &
+                           yg_T, yg_Q, &
+                           yGamma_dTs_phiT, yGamma_dQs_phiQ, &
+                           ydTs_ins, ydqs_ins &
+                           )
+         ELSE !
+           AcoefH(:) = AcoefH_0(:)
+           AcoefQ(:) = AcoefQ_0(:)
+           BcoefH(:) = BcoefH_0(:)
+           BcoefQ(:) = BcoefQ_0(:)
+           yg_T(:) = 0.
+           yg_Q(:) = 0.
+           yGamma_dTs_phiT(:) = 0.
+           yGamma_dQs_phiQ(:) = 0.
+           ydTs_ins(:) = 0.
+           ydqs_ins(:) = 0.
+         ENDIF   ! (iflag_split .eq. 2)
+       ENDIF  ! (iflag_split .eq.0)
 !!!
        IF (prt_level >=10) THEN
-         PRINT *,'pbl_surface (fuse->): yt(1,:) ',yt(1,:)
-         PRINT *,'pbl_surface (fuse->): yq(1,:) ',yq(1,:)
-         PRINT *,'pbl_surface (fuse->): yu(1,:) ',yu(1,:)
-         PRINT *,'pbl_surface (fuse->): yv(1,:) ',yv(1,:)
-         PRINT *,'pbl_surface (fuse->): AcoefH(1) ',AcoefH(1)
-         PRINT *,'pbl_surface (fuse->): BcoefH(1) ',BcoefH(1)
+         PRINT *,'pbl_surface (merge->): yt(1,:) ',yt(1,:)
+         PRINT *,'pbl_surface (merge->): yq(1,:) ',yq(1,:)
+         PRINT *,'pbl_surface (merge->): yu(1,:) ',yu(1,:)
+         PRINT *,'pbl_surface (merge->): yv(1,:) ',yv(1,:)
+         PRINT *,'pbl_surface (merge->): AcoefH(1), AcoefQ(1), AcoefU(1), AcoefV(1) ', &
+                                         AcoefH(1), AcoefQ(1), AcoefU(1), AcoefV(1)
+         PRINT *,'pbl_surface (merge->): BcoefH(1), BcoefQ(1), BcoefU(1), BcoefV(1) ', &
+                                         BcoefH(1), BcoefQ(1), BcoefU(1), BcoefV(1)
+
        ENDIF
 
+!  Save initial value of z0h for use in evappot (z0h wiil be computed again in the surface models)
+          yz0h_old(1:knon) = yz0h(1:knon)
+!
 !****************************************************************************************
 !
